attribute vec4 vPosition;
attribute vec2 vCoord;

uniform float imageWidthFactor;
uniform float imageHeightFactor;
uniform float sharpness;

varying vec2 textureCoordinate;
varying vec2 leftTextureCoordinate;
varying vec2 rightTextureCoordinate;
varying vec2 topTextureCoordinate;
varying vec2 bottomTextureCoordinate;

varying float centerMultiplier;
varying float edgeMultiplier;

void main()
{
    gl_Position = vPosition;

    vec2 widthStep = vec2(imageWidthFactor, 0.0);
    vec2 heightStep = vec2(0.0, imageHeightFactor);

    vec2 st = vCoord.st;

    textureCoordinate = st.xy;
    leftTextureCoordinate = st.xy - widthStep;
    rightTextureCoordinate = st.xy + widthStep;
    topTextureCoordinate = st.xy + heightStep;
    bottomTextureCoordinate = st.xy - heightStep;

    centerMultiplier = 1.0 + 4.0 * sharpness;
    edgeMultiplier = sharpness;
}