#extension GL_OES_EGL_image_external : require
precision mediump float;
varying vec2 textureCoordinate;
uniform sampler2D vTexture;
uniform sampler2D vMaskTexture;
uniform vec4 uStroke;
uniform float uStrokeMin;
uniform float uStrokeMax;
uniform float uFrameWidth;
uniform float uFrameHeight;

void main() {
    float frameStrokeWidth = 20.0 * (uStrokeMax - uStrokeMin);

    vec2 st = textureCoordinate.st;

    vec4 textureColor = texture2D(vTexture, textureCoordinate);
    vec4 maskColor = texture2D(vMaskTexture, textureCoordinate);
    float alpha = maskColor.a;
    if (st.s <= (frameStrokeWidth / uFrameWidth) || st.s >= (1.0 - (frameStrokeWidth / uFrameWidth)) ||
    st.t <= (frameStrokeWidth / uFrameHeight) || st.t >= (1.0 - (frameStrokeWidth / uFrameHeight))) {
        if (alpha > uStrokeMin) {
            gl_FragColor = uStroke;
        } else {
            gl_FragColor = vec4(0.0, 0.0, 0.0, 0.0);
        }
    } else {
        if (alpha <= uStrokeMin) {
            // background content
            gl_FragColor = vec4(0.0, 0.0, 0.0, 0.0);
        } else if (alpha >= uStrokeMax) {
            // front content
            gl_FragColor = vec4(textureColor.rgb, alpha);
        } else {
            gl_FragColor = uStroke;
        }
    }

}
