precision mediump float;
varying vec2 aCoord;
uniform sampler2D vTexture;
uniform sampler2D vTexture2;

void main() {
    vec4 textureColor = texture2D(vTexture, aCoord);
    float alpha = textureColor.a;

    vec4 textureColor2 = texture2D(vTexture2, aCoord);
    float alpha2 = textureColor2.a;

    if (alpha > 0.0) {
        vec3 backgroundColor = textureColor2.rgb * alpha2;
        float mergedAlpha = max(alpha, alpha2);

        if (alpha2 > 0.0) {
            gl_FragColor = vec4(textureColor.rgb * alpha + textureColor2.rgb * (1. - alpha), mergedAlpha);
        } else {
            gl_FragColor = textureColor;
        }
    } else {
        gl_FragColor = textureColor2;
    }
}